function gui_hlavnicb(kdo)

switch (kdo)
   
case 'init'
   % Inicializace aplikace (hlavni okno)
   %   set(gcbo,'DoubleBuffer','on');
   PlotCMPX;   							% Jednotkova kruznice + spol
   UpdatePoles;							% Update textu pro poly
   PlotPoles;							% Vykresleni polu
   KresliSkImHarm('init');			% Vykresleni soustavy
   % Dale vykresleni ramecku kolem os
   KresliOkraj('a_cmpx');			
   KresliOkraj('a_prubeh');
   KresliOkraj('a_anim'); 	  
   
case 'initanimaxes'
   % Inicializace os pro animaci - vykresleni poc. pozice
   % pozor, musi byt zavolana, az jsou osy vytvorene - nesmi to byt jejich CreateFcn (jinak ERR)
   
case 'draw_cmpx'
	PlotCMPX;
   
case 'help_difrov'		% Stisk 'help' od diferencialni rovnice
   gui_help('difrov');
   
case 'help_vnejpop'		% Stisk 'help' od vnejsiho popisu
   % Rozhodneme, ktera moznost (casova/frekv. oblast) je aktivni (radiobutton)
   h = findobj('Tag','rb_cas');
   value = get(h,'Min');
   ma = get(h,'Value');
   if value == ma
      gui_help('frekvoblast');
   else
      gui_help('casoblast');
   end
      
case 'help_oper'			% Stisk 'help' od operatoroveho prenosu
   gui_help('oper');
   
case 'help_poly'
   gui_help('poly');
   
case 'help_frpr'
   gui_help('frpr');
   
case 'et_y0'
   h = findobj('Tag','t_y0');
   hod = get(gcbo,'String');
   hod = str2num(hod);
   s = sprintf('%5.2f',hod);
   set(h,'String',s);   
   
case 'et_ydot0'
   h = findobj('Tag','t_ydot0');
   hod = get(gcbo,'String');
	hod = str2num(hod);
	s = sprintf('%5.2f',hod);
   set(h,'String',s);   
  
case 'sl_m'
   h = findobj('Tag','sl_m');
   m = get(h,'Value');
   m = round(10 * m)/10;
   set(h,'Value',m);
   h = findobj('Tag','t_sliderm');
   set(h,'String',num2str(m));
   h = findobj('Tag','sl_D');
   D = get(h,'Value');
   h = findobj('Tag','sl_B');
   B = get(h,'Value');
   % vypocet T a ulozeni
   hod = sqrt(m/D);
   h = findobj('Tag','t_caskonst');
   s = sprintf('%5.2f',hod);
   set(h,'String',s,'UserData',hod,'ToolTipString',num2str(hod));   
   h = findobj('Tag','t_caskonstf');
   set(h,'String',s,'UserData',hod,'ToolTipString',num2str(hod));   
   % vypocet ksi
   hod = B/(2*sqrt(m*D));
   h = findobj('Tag','t_ksi');
   s = sprintf('%5.2f',hod);
   set(h,'String',s,'UserData',hod,'ToolTipString',num2str(hod));   
   h = findobj('Tag','t_ksif');
   set(h,'String',s,'UserData',hod,'ToolTipString',num2str(hod));      
   h = findobj('Tag','rb_frekv');
   ma = get(h,'Max');
   value = get(h,'Value');
   if value == ma
      KresliBode;
      KresliFrekvCmpx;
      UpdatePoles;
      PlotPoles;
   else
      UpdatePoles;
      PlotPoles;
   end
   
case 'sl_B'
   h = findobj('Tag','sl_B');
   B = get(h,'Value');
   B = round(10 * B)/10;
   set(h,'Value',B);
   h = findobj('Tag','t_sliderB');
   set(h,'String',num2str(B));
	h = findobj('Tag','sl_m');
   m = get(h,'Value');
	h = findobj('Tag','sl_D');
   D = get(h,'Value');
  	hod = B/(2*sqrt(m*D));
   h = findobj('Tag','t_ksi');
   s = sprintf('%5.2f',hod);
   set(h,'String',s,'UserData',hod,'ToolTipString',num2str(hod));   
   h = findobj('Tag','t_ksif');
   set(h,'String',s,'UserData',hod,'ToolTipString',num2str(hod));   
	h = findobj('Tag','rb_frekv');
   ma = get(h,'Max');
   value = get(h,'Value');
   if value == ma
      KresliBode;
      KresliFrekvCmpx;
      UpdatePoles;
      PlotPoles;
   else
      UpdatePoles;
      PlotPoles;
   end
   
case 'sl_D'
	h = findobj('Tag','sl_D');
   D = get(h,'Value');
   D = round(10 * D)/10;
   set(h,'Value',D);
   h = findobj('Tag','t_sliderD');
   set(h,'String',num2str(D));
   h = findobj('Tag','sl_m');
   m = get(h,'Value');
   h = findobj('Tag','sl_B');
   B = get(h,'Value');
   hod = sqrt(m/D);
   h = findobj('Tag','t_caskonst');
   s = sprintf('%5.2f',hod);
   set(h,'String',s,'UserData',hod,'ToolTipString',num2str(hod));   
	h = findobj('Tag','t_caskonstf');
   set(h,'String',s,'UserData',hod,'ToolTipString',num2str(hod));      
   hod = 1/D;
   h = findobj('Tag','t_zesileni');
   s = sprintf('%5.2f',hod);
   set(h,'String',s,'UserData',hod,'ToolTipString',num2str(hod));
   h = findobj('Tag','t_zesilenif');
   set(h,'String',s,'UserData',hod,'ToolTipString',num2str(hod));   
   hod = B/(2*sqrt(m*D));
   h = findobj('Tag','t_ksi');
   s = sprintf('%5.2f',hod);
   set(h,'String',s,'UserData',hod,'ToolTipString',num2str(hod));   
   h = findobj('Tag','t_ksif');
   set(h,'String',s,'UserData',hod,'ToolTipString',num2str(hod));      
	h = findobj('Tag','rb_frekv');
   ma = get(h,'Max');
   value = get(h,'Value');
   if value == ma
      KresliBode;
      KresliFrekvCmpx;
      UpdatePoles;
      PlotPoles;
   else
      UpdatePoles;
      PlotPoles;
   end
   
   case 'sl_frekv'
   h = gcbo;
   f = get(h,'Value');
   f = Zaokrouhli(f,3);
   set(h,'Value',f);
   h = findobj('Tag','t_sliderfrekv');
   set(h,'String',num2str(f));   
   KresliFrekvCmpx;
   
case 'pm_frchar'
   KresliBode;
   
case 'rb_frekv'
   h = gcbo;
   min = get(h,'Max');
   set(h,'Value',min);
   h = findobj('Tag','rb_cas');
   min = get(h,'Min');		% pouze znovu pouzijeme promennou - uspora pameti
   set(h,'Value',min);
   h = findobj('Tag','t_casoblast');
   set(h,'FontWeight','normal');
	h = findobj('Tag','t_frekvoblast');
   set(h,'FontWeight','bold');
   h = findobj('Tag','t_rozlnulpol');
   %set(h,'FontWeight','bold','FontAngle','normal','ForegroundColor',[0.3 0.3 0.3]);
   set(h,'ForegroundColor',[0.3 0.3 0.3]);
   h = findobj('Tag','pm_vstup');
   set(h,'Visible','off');
   % Zmizime panel Diferencialni rovnice
   h = findobj('Tag','o_difrov');

   set(h,'Visible','off');
	h = findobj('Tag','t_y0');
   set(h,'Visible','off');
	h = findobj('Tag','t_ydot0');
   set(h,'Visible','off');
   % Zmizime panel Operatorovy prenos
   h = findobj('Tag','o_op');
   set(h,'Visible','off');
	h = findobj('Tag','t_zesileni');
   set(h,'Visible','off');
	h = findobj('Tag','t_caskonst');
   set(h,'Visible','off');
	h = findobj('Tag','t_ksi');
   set(h,'Visible','off');
   % Zviditelnime Frekvencni prenos - texty K = ...
	h = findobj('Tag','t_zesilenif');
   set(h,'Visible','on');
	h = findobj('Tag','t_caskonstf');
   set(h,'Visible','on');
	h = findobj('Tag','t_ksif');
   set(h,'Visible','on');   
   % Zmizime panel rozlozeni polu
	h = findobj('Tag','o_prp');
   set(h,'Visible','off');
   % a jeste texty
	h = findobj('Tag','t_res1');
   set(h,'Visible','off');
	h = findobj('Tag','t_res2');
   set(h,'Visible','off');
	h = findobj('Tag','t_ims1');
   set(h,'Visible','off');
	h = findobj('Tag','t_ims2');
   set(h,'Visible','off');
   % Zmena nadpisu na Frekvencni charakteristika
   h = findobj('Tag','t_rozlpolunadpis');
   set(h,'String','Frekvenn charakteristiky','FontSize',10,'FontWeight','bold');
   h = findobj('Tag','t_difrovnadpis');
   set(h,'String','Frekvenn charakteristika','FontSize',10,'FontWeight','bold');  
	h = findobj('Tag','t_opnadpis');
   set(h,'String','Frekvenn penos','FontSize',10,'FontWeight','bold');
   h = findobj('Tag','o_frekv');
   set(h,'Visible','on');
   % Uprava viditelnosti slideru budici frekvence
   h = findobj('Tag','o_frekv');
   set(h,'Visible','on');
	h = findobj('Tag','t_sliderfrekv');
   set(h,'Visible','on');
	h = findobj('Tag','sl_frekv');
   set(h,'Visible','on');
   % Panel frekvencniho prenosu   
   h = findobj('Tag','o_frprp');
   set(h,'Visible','on');
 	h = findobj('Tag','pb_helpfpop');	% Tlacitko HELP pro frekv. pr. a oper. prenos
   set(h,'Callback','gui_hlavnicb help_frpr');
   % Uprava viditelnosti popup menu pro vyber fr. charakteristik
   h = findobj('Tag','pm_frchar');
   set(h,'Visible','on');
   % Uprava viditelnosti zaskrtavatka pro sklon char.
   h = findobj('Tag','cb_frsklon');
   set(h,'Visible','on') ;  
   % Vycistime osy prubehu
   h = findobj('Tag','a_prubeh');
   axes(h); cla;
   KresliOkraj('a_prubeh');
   % Jeste vykreslime frekv. charakteristiky (mj. kvuli prvnimu spusteni)
	KresliBode;
	KresliFrekvCmpx;

case 'rb_cas'
   % Radio Button - casova oblast (jednotk. skok)
   h = gcbo;
   min = get(h,'Max');
   set(h,'Value',min);
   h = findobj('Tag','rb_frekv');
   min = get(h,'Min');		% pouze znovu pouzijeme promennou - uspora pameti
   set(h,'Value',min);		% Min a Max jsou hodnoty pri aktivnim/neaktivnim buttonu
   h = findobj('Tag','t_casoblast');
   set(h,'FontWeight','bold');
   h = findobj('Tag','t_frekvoblast');
   set(h,'FontWeight','normal');
   h = findobj('Tag','t_rozlnulpol');
   %set(h,'FontWeight','bold','FontAngle','normal','ForegroundColor','k');   
	set(h,'ForegroundColor','k');      
   h = findobj('Tag','pm_vstup');
   set(h,'Visible','on');
	% Obnovime panel Diferencialni rovnice
   h = findobj('Tag','o_difrov');
   set(h,'Visible','on');
	h = findobj('Tag','t_y0');
   set(h,'Visible','on');
	h = findobj('Tag','t_ydot0');
   set(h,'Visible','on');
	% Zneviditelnime texty - frekvencni prenos   
   h = findobj('Tag','t_zesilenif');
   set(h,'Visible','off');
	h = findobj('Tag','t_caskonstf');
   set(h,'Visible','off');
	h = findobj('Tag','t_ksif');
   set(h,'Visible','off');  

   % Obnovime panel Operatorovy prenos
   h = findobj('Tag','o_op');
   set(h,'Visible','on');
	h = findobj('Tag','t_zesileni');
   set(h,'Visible','on');
	h = findobj('Tag','t_caskonst');
   set(h,'Visible','on');
	h = findobj('Tag','t_ksi');
   set(h,'Visible','on');  
   h = findobj('Tag','o_prp');
   set(h,'Visible','on');
   % jeste texty
	h = findobj('Tag','t_res1');
   set(h,'Visible','on');
	h = findobj('Tag','t_res2');
   set(h,'Visible','on');
	h = findobj('Tag','t_ims1');
   set(h,'Visible','on');
	h = findobj('Tag','t_ims2');
   set(h,'Visible','on');
   h = findobj('Tag','t_rozlpolunadpis');
   set(h,'String','Rozloen pl','FontSize',10);
	h = findobj('Tag','t_difrovnadpis');
   set(h,'String','Diferenciln rovnice','FontSize',10);
	h = findobj('Tag','t_opnadpis');
   set(h,'String','Opertorov penos','FontSize',10,'FontWeight','bold');
   
   h = findobj('Tag','o_frekv');
   set(h,'Visible','off');
   % Uprava viditelnosti slideru budici frekvence
   h = findobj('Tag','o_frekv');
   set(h,'Visible','off');
   h = findobj('Tag','t_sliderfrekv');
   set(h,'Visible','off');
	h = findobj('Tag','sl_frekv');
   set(h,'Visible','off');
   % Panel frekvencniho prenosu
	h = findobj('Tag','o_frprp');
   set(h,'Visible','off');
	h = findobj('Tag','pb_helpfpop');	% Tlacitko HELP pro frekv. pr. a oper. prenos
   set(h,'Callback','gui_hlavnicb(''help_oper'')');
	% Uprava viditelnosti popup menu pro vyber fr. charakteristik
   h = findobj('Tag','pm_frchar');
   set(h,'Visible','off');
   % Uprava viditelnosti zaskrtavatka pro sklon char.
   h = findobj('Tag','cb_frsklon');
   set(h,'Visible','off');
   % Vycistime osy prubehu
   h = findobj('Tag','a_prubeh');
   axes(h); cla;
	KresliOkraj('a_prubeh');

case 'pb_ukaz'		
   % Tlacitko Ukaz - spousti animaci
   h = findobj('Tag','rb_frekv');
   ma = get(h,'Max');
   value = get(h,'Value');
   h = findobj('Tag','pm_vstup');
   if value == ma
      gui_hlavnicb pb_harm
   else
      value = get(h,'Value');		% Precteme, ktery vstupni signal mame vybrany (skok/impuls)
      if value == 1					% Skok
   		KresliSkImHarm('skok');
      else
         KresliSkImHarm('impuls');
      end      
   end
   
   
case 'pb_ukazstop'
   h = gcf;
   set(h,'UserData',0);
	% Text na tlacitku a jeho Callback fce se zmeni po navratu - tady je nutne jenom vyskocit z cyklu

case 'pb_harm'
   %KresliBode
   %KresliFrekvCmp
   h = findobj('Tag','sl_frekv');
   f = get(h,'Value');
   if f > 0
      KresliSkImHarm('harm');
   else
      KresliSkImHarm('skok');
   end
   
case 'cb_frsklon'
   KresliBode;
   
otherwise
end




% ********************************************************
% ****** FUNKCE PRO KRESLENI OS PRO ROZLOZENI POLU *******
% ********************************************************

function PlotCMPX
% Nakresli osy + jednotkovou kruznici
r = 8;	% polomer kruznice

h = findobj('Tag','a_cmpx');
axes(h);
axespos = get(h,'Position');

% .. ted texty
re = text(9, -1.2, 'Re(s)','FontSize',8,'Tag','o_cmpx');   
im = text(0.8, 10, 'Im(s)','FontSize',8,'Tag','o_cmpx');
invT = text((r/2)*cos(pi/4)+0.5,(r/2)*sin(pi/4),'','FontSize',8,'Tag','t_invt');
%invTh = text(r*cos(pi/4)+1,r*sin(pi/4),'1/T = 0.00','FontSize',8,'Tag','t_invth',...%
%			'BackgroundColor',[ 0.705882352941176 0.850980392156863 0.996078431372549 ]);
%repol = text(-8,-1.5,'s1 = -0.00','FontSize',8,'Tag','t_repol','Visible','off');
x = axespos(1)+(axespos(3)/24)*-8+axespos(3)/2;
y = axespos(2)+(axespos(4)/24)*-2.2+axespos(4)/2;
repol = uicontrol('Units','pixels', ...
   'BackgroundColor',[0.705882352941176 0.8509803921568631 0.996078431372549], ...
   'FontName','Arial', ...
   'FontSize',8,...
	'HorizontalAlignment','center', ...
	'ListboxTop',0, ...
	'Position',[x y 55 14], ...
	'String','s1 = -0.00', ...
	'Style','text', ...
   'Tag','t_repol1',...
   'Visible','off');

x = axespos(1)+(axespos(3)/24)*-6+axespos(3)/2;
y = axespos(2)+(axespos(4)/24)*0.8+axespos(4)/2;
repol = uicontrol('Units','pixels', ...
   'BackgroundColor',[0.705882352941176 0.8509803921568631 0.996078431372549], ...
   'FontName','Arial', ...
   'FontSize',8,...
	'HorizontalAlignment','center', ...
	'ListboxTop',0, ...
	'Position',[x y 55 14], ...
	'String','s1 = -0.00', ...
	'Style','text', ...
   'Tag','t_repol2',...
   'Visible','off');

% textove pole - 1/T
x = axespos(1)+(axespos(3)/24)*r*cos(pi/4)+axespos(3)/2+1;
y = axespos(2)+(axespos(4)/24)*r*sin(pi/4)+axespos(4)/2;
invTh = uicontrol('Units','pixels', ...
   'BackgroundColor',[0.705882352941176 0.8509803921568631 0.996078431372549], ...
  	'FontName','Arial', ...
   'FontSize',8,...
	'HorizontalAlignment','center', ...
	'ListboxTop',0, ...
	'Position',[x y 60 14], ...
	'String','1/T = 0.00', ...
	'Style','text', ...
	'Tag','t_invth');

set(h,'NextPlot','add');
osax = line([-10 11],[0 0],'Tag','o_cmpx');
osay = line([0 0],[-10 11],'Tag','o_cmpx');
tline = line([0 r*cos(pi/4)],[0 r*sin(pi/4)],'Tag','g_sipka');
set([osax osay tline],'Color',[0 0 0]);
PlotArrow(11,0,0.5,0,'o_cmpx');
PlotArrow(0,11,0.5,90,'o_cmpx');
PlotArrow(r*cos(pi/4),r*sin(pi/4),0.5,45,'g_arrow');

% "Jednotkova" kruznice
t = 0:0.01:2*pi;
cx = r*cos(t);
cy = r*sin(t);
kruh = line(cx,cy);
set(kruh,'Tag','g_kruh');

g_pol1 = line([0 0],[0 0],'Marker','x','MarkerSize',8,'Color','r','Tag','g_pol1','Visible','off');
g_pol2 = line([0 0],[0 0],'Marker','x','MarkerSize',8,'Color','r','Tag','g_pol2','Visible','off');

pol = text(1,-9.2,'s1 = 0.000 + 0.000i','FontSize',8,'Tag','t_cmpxpol1');
pol = text(1,-10.5,'s2 = 0.000 + 0.000i','FontSize',8,'Tag','t_cmpxpol2');


% *********************************************
% ****** FUNKCE PRO KRESLENI POLU DO OS *******
% *********************************************

function PlotPoles
% Nakresli poly na "jednotkovou" kruznici 


% Aktivuj ty spravne osy
h = findobj('Tag','a_cmpx');
axes(h);

g_pol1 = findobj('Tag','g_pol1');
g_pol2 = findobj('Tag','g_pol2');

%h = findobj('Tag','g_pol1');
%if ~isempty(h)
%   delete(h)
%end

%h = findobj('Tag','g_pol2');
%if ~isempty(h)
%   delete(h)
%end

r = 8;	% polomer kruznice

% 1. pol
h = findobj('Tag','t_res1');
re = get(h,'UserData');
h = findobj('Tag','t_ims1');
im = get(h,'UserData');

if abs(im) > 0
   % poly jsou komplexni
   ang = angle(re+im*i);
   if re ~= 0
      %g_pol1 = plot(r*cos(ang),r*sin(ang),'r+','MarkerSize',8,'Tag','g_pol1');
      set(g_pol1,'XData',r*cos(ang),'YData',r*sin(ang),'Marker','+','Visible','on');
   else
      %g_pol1 = plot(r*cos(ang),r*sin(ang),'rx','MarkerSize',8,'Tag','g_pol1');   
      set(g_pol1,'XData',r*cos(ang),'YData',r*sin(ang),'Marker','x','Visible','on');
   end
   

	% 2. pol
	h = findobj('Tag','t_res2');
	re = get(h,'UserData');
	h = findobj('Tag','t_ims2');
	im = get(h,'UserData');
	ang = angle(re+im*i);
   if re ~= 0
      %g_pol2 = plot(r*cos(ang),r*sin(ang),'r+','MarkerSize',8,'Tag','g_pol2');
      set(g_pol2,'XData',r*cos(ang),'YData',r*sin(ang),'Marker','+','Visible','on');
   else
      %g_pol2 = plot(r*cos(ang),r*sin(ang),'rx','MarkerSize',8,'Tag','g_pol2');   
      set(g_pol2,'XData',r*cos(ang),'YData',r*sin(ang),'Marker','x','Visible','on');
   end
   
   % ... a taky popis 1/T
   h = findobj('Tag','t_invt');
   set(h,'String','1/T');
	h = findobj('Tag','t_caskonst');
	T = get(h,'UserData');
	T = sprintf('%5.3f',1/T);
	h = findobj('Tag','t_invth');
   set(h,'String',['1/T = ' T]);
   
   % zviditelnit kruznici + sipku + 1/T
   h = findobj('Tag','g_kruh');
   set(h,'LineStyle','-','Color','b');
   h = findobj('Tag','g_sipka');		% sipka - cara
   set(h,'LineStyle','-','Color',[ 0 0 0 ]);
   h = findobj('Tag','g_arrow');		% sipka - trojuhelnik
   set(h,'FaceColor',[0 0 0],'EdgeColor',[0 0 0]);
	h = findobj('Tag','t_invt');
   set(h,'Color',[ 0 0 0 ]);
	h = findobj('Tag','t_invth');
   set(h,'Visible','on');
   
   % zneviditelnit text realnych polu
	h = findobj('Tag','t_repol1');
   set(h,'Visible','off');
	h = findobj('Tag','t_repol2');
   set(h,'Visible','off');


else
   % poly jsou realne
   
   % nacteme hodnotu druheho polu
	h = findobj('Tag','t_res2');
	re2 = get(h,'UserData');
   
   % ... a taky popis 1/T
   % najdeme vetsi (resp. mensi) z korenu
   %h = findobj('Tag','t_invt');
   %set(h,'String','max\{s1,s2\}');
   minim = min([re re2]);
	%minims = sprintf('%5.2f',minim);
	%h = findobj('Tag','t_invth');
   %set(h,'String',['max\{s1,s2\} = ' minims])
   
   % vykreslime poly, musime normovat podle vetsiho
   %g_pol1 = plot(r/abs(minim)*re,0,'rx','MarkerSize',8,'Tag','g_pol1');
   set(g_pol1,'XData',r/abs(minim)*re,'YData',0,'Marker','x','Visible','on');
   if re ~= re2
      %g_pol2 = plot(r/abs(minim)*re2,0,'rx','MarkerSize',8,'Tag','g_pol2');
      set(g_pol2,'XData',r/abs(minim)*re2,'YData',0,'Marker','x','Visible','on');
   else
      set(g_pol2,'XData',r/abs(minim)*re2,'YData',0,'Marker','+','Visible','on');
   end
   
   
   % zneviditelnit kruh + sipku + 1/T
   h = findobj('Tag','g_kruh');
   set(h,'LineStyle','-.','Color',[ 0.9 0.9 0.9 ]);
   h = findobj('Tag','g_sipka');		% sipka - cara
   set(h,'LineStyle','-.','Color',[ 0.9 0.9 0.9 ]);
   h = findobj('Tag','g_arrow');		% sipka - trojuhelnik
   set(h,'FaceColor',[0.9 0.9 0.9],'EdgeColor',[0.9 0.9 0.9]);

	h = findobj('Tag','t_invt');
   set(h,'Color',[ 0.9 0.9 0.9 ]);
	h = findobj('Tag','t_invth');
   set(h,'Visible','off');
   
   % pocitame s tim, ze prvni pol je vetsi (resp. mensi, zapornejsi)
   h = findobj('Tag','t_res1');
	re = get(h,'UserData');
   re = sprintf('%5.2f',re);
	h = findobj('Tag','t_repol1');
   set(h,'Visible','on','String',['s1 = ' re]);
   h = findobj('Tag','t_res2');
	re = get(h,'UserData');
   re = sprintf('%5.2f',re);
   h = findobj('Tag','t_repol2');
   set(h,'Visible','on','String',['s2 = ' re]);
end

% ***************************************
% ****** FUNKCE PRO UPDATE POLU *******
% ***************************************
% ** Prepise texty s hodnotami polu **
function UpdatePoles;

% hodnoty souradnic polu a T se uchovavaji i jako ciselne hodnoty v UserData

   h = findobj('Tag','t_ksi');
   ksi = get(h,'UserData');
   h = findobj('Tag','t_caskonst');
   T = get(h,'UserData');
   poles = roots([T^2 2*ksi*T 1]);
   
   h = findobj('Tag','t_res1');
	hod = real(poles(1));
	s = sprintf('%5.2f',hod);
   set(h,'String',s,'UserData',hod,'ToolTipString',num2str(hod));   
   
	h = findobj('Tag','t_res2');
   hod = real(poles(2));
	s = sprintf('%5.2f',hod);
   set(h,'String',s,'UserData',hod,'ToolTipString',num2str(hod));   

	if ~isreal(poles(1))
		h = findobj('Tag','t_ims1');
	   hod = imag(poles(1));   
		s = sprintf('%5.2f',hod);
   	set(h,'String',s,'HorizontalAlignment','right','UserData',hod,'ToolTipString',num2str(hod));
		h = findobj('Tag','t_ims2');
   	hod = imag(poles(2));   
		s = sprintf('%5.2f',hod);
   	set(h,'String',s,'HorizontalAlignment','right','UserData',hod,'ToolTipString',num2str(hod));		
   else
      h = findobj('Tag','t_ims1');
	   set(h,'String','-','HorizontalAlignment','center','UserData',0,'ToolTipString','0');
		h = findobj('Tag','t_ims2');
      set(h,'String','-','HorizontalAlignment','center','UserData',0,'ToolTipString','0');
   end
   
   h = findobj('Tag','t_cmpxpol1');
	set(h,'String',['s1 = ' num2str(Zaokrouhli(poles(1),4))]);
	h = findobj('Tag','t_cmpxpol2');
   set(h,'String',['s2 = ' num2str(Zaokrouhli(poles(2),4))]);
   
% ****************************************
% ****** FUNKCE PRO KRESLENI SIPKY *******
% ****************************************

function PlotArrow(x,y,size,angle,tag,color)
% Nakresli sipku
if nargin<5
   tag='';
end
if nargin<6
   color = 'k';
end


sipka = patch(size*[0 -1 -1] + x,size*[0 0.5 -0.5] + y,[0 0 0]);
rotate(sipka, [0 0 1], angle, [x y 0]);
set(sipka,'Tag',tag,'EdgeColor',color,'FaceColor',color);




% *************************
% ****** POPISE OSY *******
% *************************
function PopisOsy(params)
% Params je struktura, ktera obsahuje potrebna data

ax = findobj('Tag',params.axtag);
set(ax,'NextPlot','add');

tte = text(params.popisxx,params.popisxy,params.t_popisx,'FontSize',8);
yte = text(params.popisyx,params.popisyy,params.t_popisy,'FontSize',8);
nula = text(params.osayxpos-10,params.osaxypos-40,'0','FontSize',8,...
         'HorizontalAlignment','right','Color','k');
      


% ************************************************************************
% ****** FUNKCE PRO KRESLENI ODEZEV V CASOVE OBLASTI (SKOK/IMPULS) *******
% ************************************************************************

function KresliSkImHarm(co)

if ~strcmp(co,'init')					% pro inicializaci ...
   params.axtag = 'a_prubeh';
   ax = findobj('Tag',params.axtag);
   axes(ax); cla;
   KresliOkraj('a_prubeh');
   % Nacteme konstanty a vypocitame odezvu
	h = findobj('Tag','t_caskonst');
   T = get(h,'UserData');
   h = findobj('Tag','t_ksi');
   ksi = get(h,'UserData');
   h = findobj('Tag','t_zesileni');
   zesileni = get(h,'UserData');
   num = zesileni;
   den = [T^2 2*T*ksi 1];   

   tt = tf(num,den);		% Prenosova funkce
   
	delkat = 770;			% Delka casove osy v pixelech
   delkay = 700;			% Delka osy vystupu v pixelech
   params.xlim = 1000;
   params.ylim = 1000;
	scale = 1;

   
switch(co)
case 'skok'

   [y,t]=step(tt);   
   vstup = ones(1,length(t));	
   maxy = max(y);	maxt = max(t);
  	%if maxy < 1
   %  maxy = 1;
   %end
   maxy = max(maxy,1);
   params.maxt = maxt;
   yorig = y;
   y = y/maxy*delkay+100;							% Normovani vystupu, +100 je offset osy
   vstup = vstup/abs(maxy)*delkay+100;		% Normovani skoku
	params.osaxypos = scale*100;
   params.popisxx = scale*900; params.popisxy = scale*50;
   if ksi>0
      usthod = yorig(length(yorig));
      usthods = y(length(y));
   else
      usthod = zesileni;
      usthods = zesileni/abs(maxy)*delkay+100;
   end
   
case 'impuls'
   [y,t]=impulse(tt);
   vstup = zeros(1,length(t));
   vstup(1,1:4) = 1;
   maxy = max(y);	maxt = max(t);							
   miny = min(y);																% U impulsovky muzeme jit do zaporu
   params.maxt = maxt;
   
   %if maxy < 1
   %   maxy = 1;
   %end
   maxy = max(maxy,1);
   
   yorig = y;
   stred = (maxy + miny)/2;												% stred obrazce
   y = (y - stred)/(maxy-miny)*delkay + params.xlim/2;			% Normovani vystupu a vystredeni
   params.osaxypos = y(1);
   vstup = (vstup)/(maxy-miny)*delkay + y(1);							% Normovani skoku a posunuti
   params.popisxx = scale*900; params.popisxy = scale*50 + y(1) - 100;
   if ksi>0
      usthod = yorig(length(yorig));
      usthods = y(length(y));
   else
      usthod = 0;
      usthods = - (stred)/(maxy-miny)*delkay + params.xlim/2;
   end
   
case 'harm'
      
   % Jaka je frekvence
   h = findobj('Tag','sl_frekv');
   f = get(h,'Value');
   
   % Delka simulace
   delka = 10/f;	% delka je 10 period
   
   [vstup,ti] = gensig('sin',1/f,delka);
%	warning off;
   [y,t] = lsim(tt,vstup,ti);
%   warning on;
   maxy = max(y);	miny = min(y);
   % Musime se ridit podle vstupu - pro male f dochazi k resamplovani vstupu, delka je pak polovicni
   maxt = t(length(vstup));			
   
   maxy = max(maxy,1);
   miny = min(miny,-1);
   
   params.maxt = maxt;
   yorig = y;
   stredy = (maxy + miny)/2;
   %   y = y/(abs(maxy)+abs(miny))*delkay+params.ylim/2-stredy;
   y = (y-stredy)/(abs(maxy)+abs(miny))*delkay+params.ylim/2;
   vstup = (vstup-stredy)/(abs(maxy)+abs(miny))*delkay+params.ylim/2-stredy;		% Normovani skoku
	params.osaxypos = scale*(params.ylim/2-stredy*delkay/(abs(maxy)+abs(miny)));
   params.popisxx = scale*900; params.popisxy = scale*(params.ylim/2-stredy/(abs(maxy)+abs(miny))*delkay)+50;
   
   % Urcime maximalni hodnotu vystupu
   % pouzijeme promennou usthod, protoze se mi to nechce prepisovat ;-)
   usthod = max(yorig);																	% puvodni hodnota
   usthods = (usthod-stredy)/(abs(maxy)+abs(miny))*delkay+params.ylim/2;	% ... a v meritku ...
   
otherwise
end

	osaimx = 100;   
  
	t = t/maxt*delkat;
   maxt = max(t);	% Znovu spocitame pro normovane hodnoty
   params.maxts = maxt;	% ... uz s meritkem

	t = t + 100;	% Osa x ma y souradnici 100
      
	scale = 1;

	%params.osaxypos = scale*850;
	
	params.osayxpos = scale*osaimx;
	params.osaxod = scale*60;
	params.osaxdo = scale*920;

	params.osayod = scale*60;
	params.osaydo = scale*920;

	params.sipkaxx = scale*930;
	params.sipkaxy = params.osaxypos;
	params.sipkasize = scale*25;

	params.sipkayy = scale*930;

   
  	params.popisyx = scale*20;params.popisyy = scale*960;
   params.t_popisx = 't[s]';params.t_popisy = 'y[m]';
   
	
   
	KresliOsy(params);
   PopisOsy(params);
   
   
   
   % ********** Popis casove osy (v pulce a na konci) **********      
	tpulp = text(params.maxts/2+100,params.osaxypos,'+','Color','k','HorizontalAlignment','center','FontSize',8);
	tpult = text(params.maxts/2+100,params.osaxypos-40,num2str(params.maxt/2,2),'Color','k',...
   	'HorizontalAlignment','center','FontSize',8);
	tp = text(params.maxts+100,params.osaxypos,'+','Color','k','HorizontalAlignment','center','FontSize',8);
	tpt = text(params.maxts+100,params.osaxypos-40,num2str(params.maxt,2),...
   	'HorizontalAlignment','right','Color','k','FontSize',8);

	% ********** Kung-fu - legenda pokracuje ***********
	% Pouzijeme znovy promenne, protoze puv. hodnoty nebudeme potrebovat
	tpulp = text(params.xlim/4,params.ylim-60,'Budic signl','Color','r','HorizontalAlignment','center','FontSize',8);
	tpulp = line([params.xlim/4+110 params.xlim/4+225],[params.ylim-60 params.ylim-60],...
   	'LineStyle','--','Color','r');
	tpulp = text(3*params.xlim/4-50,params.ylim-60,'Vstup','Color','b','HorizontalAlignment','center','FontSize',8);
	tpulp = line([3*params.xlim/4+20 3*params.xlim/4+115],[params.ylim-60 params.ylim-60],...
   	'LineStyle','-','LineWidth',1.5,'Color','b');

   % pl je prechodovka/impulsovka, vs je vstupni signal - pripravime si handle
   vs = line([0 0],[0 0],'Color','r','EraseMode','background','LineStyle','--');
   pl = line([0 0],[0 0],'EraseMode','background','LineWidth',1.5);	% Defaultni sirka je 0.5
   
   if ~strcmp(co,'harm')
      % Jednicka - popisek pro vstupni signal
      if vstup(1) > (params.osaxypos + 30)
         jedna = text(params.osayxpos-5,vstup(1),'1','Color','r','HorizontalAlignment','right','FontSize',8);
         jedna = line(params.osayxpos,vstup(1),'Marker','+','Color','r','MarkerSize',4);
      else
         jedna = text(params.osayxpos-5,params.osaxypos + 30,'1','Color','r','HorizontalAlignment','right','FontSize',8);
      end   
         
   	% Ustalena hodnota
   	asymp = line([params.osayxpos params.osayxpos+delkat],[usthods usthods],'LineStyle','--');
		%cislo = num2str(usthod,2);
		%if length(cislo)>4
   	%	cislo = num2str(usthod,1);
   	%end
   	%if length(cislo)>4
   	%	cislo = num2str(round(usthod));
      %end
      usthod = Zaokrouhli(usthod,2);
      cislo = num2str(usthod);

   else
      % Jednicka - popisek pro vstupni signal
      if max(vstup) > params.osaxypos + 30
         jedna = text(params.osayxpos-5,max(vstup),'1','Color','r','HorizontalAlignment','right','FontSize',8);
         jedna = line(params.osayxpos,max(vstup),'Marker','+','Color','r','MarkerSize',4);         
      else
         jedna = text(params.osayxpos-5,params.osaxypos + 40,'1','Color','r','HorizontalAlignment','right','FontSize',8);
		end
	end
   
   if ((usthod<0.94)|(usthod>1.06))&(usthod>0.06)
      usthod = Zaokrouhli(usthod,2);
      if usthod > 10
         usthod = Zaokrouhli(usthod,1);
      end
      
      cislo = num2str(usthod);
		maxyt = text(params.osayxpos-5,usthods,cislo,'FontSize',8,...
         'HorizontalAlignment','right','Color','b');
		maxyt = line(params.osayxpos,usthods,'Marker','+','Color','b','MarkerSize',4);

    elseif (usthod <= 0.06)
         if usthod > 0.01
            usthod = Zaokrouhli(usthod,2);
		      cislo = num2str(usthod);
	         maxyt = text(params.osayxpos-5,params.osaxypos+30,cislo,'FontSize',8,...
               'HorizontalAlignment','right','Color','b');
         else            
            cislo = num2str(usthod);
            if strcmp(co,'harm')				% Pro harm. signal amplituda, pro skok/impuls ust. hod.
            	maxyt = text(params.xlim/2,40,['Amplituda (maximum) y_m = ' cislo ' m'],'FontName','MS Sans Serif','FontSize',8,...
                  'HorizontalAlignment','center','Color','b');
            else
               maxyt = text(params.xlim/2,860,['Ustlen hodnota y_u = ' cislo ' m'],'FontName','MS Sans Serif','FontSize',8,...
                  'HorizontalAlignment','center','Color','b');
            end            
			end
    end
 
         
 	end			% pro inicializaci - if ~strcmp(co,'init') ....
 
   ax = findobj('Tag','a_anim');
   axes(ax);
   cla;
   KresliOkraj('a_anim');
	set(ax,'XLim',[-1.5 4],'YLim',[-10 10]);
   set(ax,'DrawMode','fast','Color','w');
	%   f = gcf;
   %	set(f,'DoubleBuffer','on','BackingStore','off','Color','none');
   % Data pro patche
   delpruz = 3.5;
   yoffset = 3.9;
   xoffset = 1.2;
	xpruzina = [0.5 1 0 1 0 1 0 1 0.5]*0.5-0.25;
	ypruzina = ([0.25 0.5 1 1.5 2 2.5 3 3.5 3.75]-0.25)/delpruz;
	% Pruzina - data pro y jsou definovana od 0 a normovana na delku 1 - nutne pro animaci
	xzavazi = xoffset + [1 1 -1 -1];
   yzavazi = yoffset + [-.7 .7 .7 -.7];
	xkpruzine = xoffset + [0 0];
   ykpruzine = yoffset + [0.7 1.35];
	xktlumici = xoffset + [0 0];
	yktlumici = yoffset + [-0.7 -3.3];
	xtlumic1 = xoffset + [-0.35 0.35];
	ytlumic1 = yoffset + [-3.5 -3.5];
	xtlumic2 = xoffset + [-0.4 -0.4 0.4 0.4];
   ytlumic2 = yoffset + [-2 -5 -5 -2];
   xm = xoffset + 2;
   ym = yoffset;
	xB = xoffset + 2;
   yB = yoffset - 3.5;
   xD = xoffset + 2;
   yD = yoffset + 1.5 + 1.25;

   kpruzine = line(xkpruzine,ykpruzine,'Color','k','LineWidth',3,'EraseMode','xor');
	ktlumici = line(xktlumici,yktlumici,'Color','k','LineWidth',3,'EraseMode','xor');
	pruzina = line(xpruzina,ypruzina,'Color','k','LineWidth',3,'EraseMode','xor');
	tlumic1 = line(xtlumic1,ytlumic1,'Color','k','LineWidth',8,'EraseMode','xor');
	tlumic2 = line(xtlumic2,ytlumic2,'Color','k','LineWidth',2.5);
	%zavazi = patch(xzavazi,yzavazi,'k','LineWidth',3,'FaceVertexCData',[0.15 0.15 0.15;0.3 0.3 0.3;0.3 0.3 0.3;0.3 0.3 0.3],...
   %   'FaceColor','interp','EraseMode','xor'); - hezke, ale nefunguje pri animaci
   zavazi = patch(xzavazi,yzavazi,[0.8 0.8 0.8],'LineWidth',3,'EraseMode','xor');
   
   % zem a strop
   zemastrop = line(xoffset+[-1.3 1.3],yoffset+[-5.1 -5.1],'LineWidth',3,'Color','k');
   zemastrop = line(xoffset+[-1.3 1.3],yoffset+[4.1 4.1],'LineWidth',3,'Color','k');
   
   tm = text(xm,ym,'m','FontName','MS Sans Serif','FontSize',10,'FontWeight','bold','Color','k','EraseMode','xor');
   tB = text(xB,yB,'B','FontName','MS Sans Serif','FontSize',10,'FontWeight','bold','Color','k');
   tD = text(xD,yD,'D','FontName','MS Sans Serif','FontSize',10,'FontWeight','bold','Color','k','EraseMode','xor');
   mpos = get(tm,'Position');
	Dpos = get(tD,'Position');

	delpruz = 2.5;
   set(pruzina,'XData',xoffset+xpruzina,'YData',ypruzina*(delpruz)+yoffset+1.5);
   
	h = findobj('Tag','pb_ukaz');
   set(h,'String','Stop','Callback','gui_hlavnicb pb_ukazstop');
   rb = findobj('Tag','rb_cas');
   rb = [rb findobj('Tag','rb_frekv')];
   set(rb,'Enable','off');
   
	if ~strcmp(co,'init')	% pouze pokud neprobiha inicializace	.... je to pridano az dodatecne, asi by to slo i lip
   xpl = []; xpls = []; 
   ypl = []; ypls = []; 
   
   data = yorig/(max(yorig)-min(yorig))*1.3;
   
   maxtext = Zaokrouhli(max(yorig),2);
   if maxtext < 0.01
      maxtext = sprintf('%0.2g',max(yorig));
   else
      maxtext = num2str(max(yorig),'%0.2g');
   end
   
   mintext = Zaokrouhli(min(yorig),2);
   if mintext < 0.01
      mintext = sprintf('%0.2g',min(yorig));
   else
      mintext = num2str(min(yorig),'%0.2g');
   end
   
   pop = text(xoffset-1.2,max(data)+yoffset,[maxtext ' -'],'FontSize',8,'HorizontalAlignment','right');
   pop = text(xoffset-1.2,min(data)+yoffset,[mintext ' -'],'FontSize',8,'HorizontalAlignment','right');
   figHndl = gcf;
   set(figHndl,'UserData',1);
   i = 1;
   
   while ((i < length(vstup)) & get(figHndl,'UserData') == 1)
      i = i + 1;
      tic;
      xpl = [xpl t(i)];ypl = [ypl y(i)];
		xpls = [xpls t(i)];ypls = [ypls vstup(i)];
   	set(pruzina,'XData',xoffset+xpruzina,'YData',(ypruzina*(delpruz-data(i)))+data(i)+yoffset+1.5);
   	% pruzina - y-data jsou nasobena meritkem = (delka pruziny-aktualni vychylka systemu (data(i))
	   % pak je pripoctena aktualni vychylka (aby pruzina byla na jednom miste) a 1.5 je posunuti pruziny oproti 0
      set(zavazi,'YData',yzavazi+data(i));
	   set(kpruzine,'YData',ykpruzine+data(i));
	   set(ktlumici,'YData',yktlumici+data(i));
      set(tlumic1,'YData',ytlumic1+data(i));
      set(pl,'XData',xpl,'YData',ypl);
      set(vs,'XData',xpls,'YData',ypls);
      set(tm,'Position',[mpos(1) ym+data(i) mpos(3)]);
      set(tD,'Position',[Dpos(1) ypruzina(5)*(delpruz-data(i))+data(i)+yoffset+1.5 Dpos(3)]);
      drawnow;
      while mytoc<0.02
      end         
   end
   
	end		   % end - pouze pokud neprobiha inicializace
	set(h,'String','Uka','Callback','gui_hlavnicb pb_ukaz');
   set(rb,'Enable','on');
   
% ****************************************************************************
% ****** FUNKCE PRO KRESLENI FREKV. CHAR. V KOMPLEXNI ROVINE (NYQUIST) *******
% ****************************************************************************
function KresliFrekvCmpx
% Pri kazdem volani se kresli i osy atd. Je to sice mene efektivni, ale preprogramovani by bylo dost hokna
% a asi by byl i celkem narust delky kodu
%figure
%ax = gca;
ax = findobj('Tag','a_frekvcmpx');
axes(ax);cla;
set(ax,'NextPlot','add');
%set(ax,'Tag','a_frekvcmpx2');
KresliOkraj('a_frekvcmpx');

%	ax = findobj('Tag','a_cmpx');
	params.axtag = 'a_frekvcmpx';
	% Nacteme konstanty a vypocitame odezvu
	h = findobj('Tag','t_caskonst');
	T = get(h,'UserData');
	h = findobj('Tag','t_ksi');
	ksi = get(h,'UserData');
	h = findobj('Tag','t_zesileni');
	zesileni = get(h,'UserData');
	num = zesileni;
	den = [T^2 2*T*ksi 1];   

	tt = tf(num,den);		% Prenosova funkce
   [re,im,w] = nyquist(tt);
   h = findobj('Tag','sl_frekv');
   f = get(h,'Value');	% Nacti frekvenci ze slideru pro vykresleni cary (vektoru)
   [rev,imv] = nyquist(tt,2*pi*f);	% Nyquist bere omega, tj. omega=2*pi*f [rad/s]
   angle = atan2(imv,rev)*180/pi;	% Uhel pro vykresleni sipky
  	maxre = max(re); minre = min(re);  
	maxim = max(im); minim = min(im);
	delkare = 640;
	delkaim = 410;
	params.xlim = 1000;
   params.ylim = 1000;
	scale = 1;
   params.osaxypos = scale*600;
   
   re = re/(maxre-minre)*delkare;
   rev = rev/(maxre-minre)*delkare;

	maxre = max(re);	% Znovu spocitame pro normovane hodnoty
	minre = min(re);

	stredre = (maxre + minre)/2 + 40;		% stred obrazce - je trochu vyoseny, aby se veslo K u omega=0
   re = re + params.xlim/2 - stredre;		% umistime do stredu Re osy
   rev = rev + params.xlim/2 - stredre;		% umistime do stredu Re osy

   if (abs(maxim)-abs(minim)) ~= 0
      im = -im/(abs(maxim)-abs(minim))*delkaim+params.osaxypos;	
      imv = -imv/(abs(maxim)-abs(minim))*delkaim+params.osaxypos;
   else
      im = im + params.osaxypos;
      imv = imv + params.osaxypos;
   end
   
	osaimx = re(length(re));

	params.osayxpos = scale*osaimx;
   params.osaxypos = scale*600;
   
   params.osaxod = scale*60;
	params.osaxdo = scale*920;

	params.osayod = scale*60;
	params.osaydo = scale*640;

	params.sipkaxx = scale*930;
	params.sipkaxy = params.osaxypos;
	params.sipkasize = scale*25;

	params.sipkayy = scale*660;

	params.popisyx = scale*params.osayxpos-30; params.popisyy = scale*params.osaxypos+90;
	params.popisxx = scale*815; params.popisxy = scale*params.osaxypos+40;

   params.t_popisx = 'Re\{F(j\omega)\}';params.t_popisy = 'Im\{F(j\omega)\}';
   
   KresliOsy(params);
   PopisOsy(params);
   
   % Vykresleni vektoru a popisky+znacky na Im ose. Pouzijeme promennou vektor nekolikrat
   % Vse probehne jen pokud fr. char. neni totozna s Re osou
   if minim ~= 0
	   vektor = line([params.osayxpos rev],[params.osaxypos imv],'Color','b','LineStyle','--');   
		vektor = text(params.osayxpos-20,min(im)-20,num2str(Zaokrouhli(minim,2)),'Color','k',...
      	'HorizontalAlignment','right','FontSize',8);
	   vektor = line(params.osayxpos,min(im),'Marker','+','Color','b','MarkerSize',7);
   	PlotArrow(rev,imv,25,angle);   	% Sipka na konci vektoru
	   % Sipka pro rostouci omega
   	%vektor = line([params.xlim/2-stredre+50 params.xlim/2-stredre+150],[min(im)-30 min(im)-30],'Color','b');
	  	vektor = line([stredre+abs(minre)+120 stredre+abs(minre)+220],[min(im)-30 min(im)-30],'Color','b');
   	PlotArrow(stredre++abs(minre)+110,min(im)-30,25,180,'','b');   	% Sipka na konci vektoru
	   vektor = text(stredre+abs(minre)+170,min(im)-50,'\omega','Color','b',...
   	   'HorizontalAlignment','center','FontSize',8);
	   % Omega = 0 v cervene barve + K taky v cervene
   	vektor = line(re(1),params.osaxypos,'Marker','.','Color','r');	% Tecka na Re ose    
	   vektor = text(re(1)+10,params.osaxypos-40,'\omega = 0','Color','r','FontSize',8);
		vektor = text(re(1)-5,params.osaxypos+40,'K','Color','r','FontSize',8,'HorizontalAlignment','left');
	   vektor = text(re(length(re))-10,params.osaxypos+25,'\omega\rightarrow\infty','Color','r',...
      			'FontSize',8,'HorizontalAlignment','right');
	else
	   % Sipka pro rostouci omega
   	vektor = line([params.xlim/2-50 params.xlim/2+50],[min(im)-30 min(im)-30],'Color','b');
	   PlotArrow(params.xlim/2+50,min(im)-30,25,0,'','b');   	% Sipka na konci vektoru
	   vektor = text(params.xlim/2,min(im)-50,'\omega','Color','b',...
	      'HorizontalAlignment','center','FontSize',8);
   end
   
   ny = line(scale*re(:),scale*im(:));
   
% ********************************************************************************
% ****** FUNKCE PRO KRESLENI BODEHO (FAZOVE A AMPLITUDOVE) CHARAKTERISTIKY *******
% ********************************************************************************
function KresliBode
% Pri kazdem volani se kresli i osy atd. Je to sice mene efektivni, ale preprogramovani by bylo dost hokna
% a asi by byl i celkem narust delky kodu
	ax = findobj('Tag','a_frekvbode');
	axes(ax);cla;
   set(ax,'NextPlot','add');
   KresliOkraj('a_frekvbode');

%	ax = findobj('Tag','a_cmpx');
	params.axtag = 'a_frekvbode';
	% Nacteme konstanty a vypocitame odezvu
	h = findobj('Tag','t_caskonst');
	T = get(h,'UserData');
	h = findobj('Tag','t_ksi');
	ksi = get(h,'UserData');
	h = findobj('Tag','t_zesileni');
	zesileni = get(h,'UserData');
	num = zesileni;
	den = [T^2 2*T*ksi 1];   

	tt = tf(num,den);		% Prenosova funkce

	[m,p,w1] = bode(tt);

	mdB = 20*log10(m);
	w1 = log10(w1);

	sc = 650/(w1(length(w1))-w1(1));	% sirka mezi svislymi osami

	% Pozice napisu Re{F(jw)} a Im ...
	fix = 680;
	fiy = 402;
	Fx = 40;
	Fy = 402;
	logwx = 744;	
   logwy = 222;
   xoffset = 80;
   jedndelka = 70;

	% Toto je y pozice osy x ;-)
	ypos = 200;

	osax = line([20 800],[ypos ypos],'Color','k');
	osaampl = line([80 80],[20 380],'Color','k');
	osafaze = line([730 730],[20 380],'Color','k');

	PlotArrow(730,390,15,90);
	PlotArrow(xoffset,390,15,90);
	PlotArrow(810,200,15,0);

	set(ax,'XLim',[0 830],'YLim',[0 500]);
	F = text(Fx-20,Fy,'|F(j\omega)|_{dB}','FontSize',8);
	%Fo = text(Fx+34,Fy,'w','FontName','Symbol');
	%	FdB = text(Fx+69,Fy-4,'dB','FontSize',8);

	fi = text(fix+16,fiy,'\phi(j\omega)','FontSize',8);
	%fi = text(fix+64,fiy,'\phi(j\omega)\newline[rad]','FontSize',8,'HorizontalAlignment','left');

	%Imo = text(fix,fiy,'f   w','FontName','Symbol');

	logw = text(logwx,logwy,'log \omega','FontSize',8);
	%logwo = text(logwx+34,logwy,'w','FontName','Symbol');

   % Urcime, kterou charakteristiku vykreslime - nacteme stav popup menu
   % Hodnoty 'pop' - 1 = Obe, 2 = Amlpitudova, 3 = Fazova
   pop = findobj('Tag','pm_frchar');
   pop = get(pop,'Value');
   % Pokud je zobrazena jenom fazova ch., deaktivuj zaskrtavatko pro zobrazeni sklonu, jinak aktivuj
   % pouzijeme promennou txt, ktera se bude pouzivat i dal - toto bylo pripsano pozdeji, proto txt
   txt = findobj('Tag','cb_frsklon');
   if (pop == 3)		
      set(txt,'Enable','off');
   else
		set(txt,'Enable','on');
   end
   if (pop == 1)|(pop == 2)
		% Vykresleni znacek a hodnot na ose F      
      for i = 0:1
   		txt = text(Fx-30,ypos+(i+1)*jedndelka,['+' num2str((i+1)*20)],'FontSize',8);
   		txt = line(Fx+40,ypos+(i+1)*jedndelka,'Color','k','Marker','+','MarkerSize',3);
	   	txt = text(Fx-30,ypos-(i+1)*jedndelka,[num2str(-(i+1)*20)],'FontSize',8);
   	   txt = line(Fx+40,ypos-(i+1)*jedndelka,'Color','k','Marker','+','MarkerSize',3);
      end
      txt = text(Fx+10,ypos-15,'0','FontSize',8);

   	% Amplitudova charakeristika
      line((w1(:)+abs(w1(1)))*sc+xoffset,mdB(:)*jedndelka/20+ypos); % jedndelka = jednotkova delka, kolik je mezi dvema znackami pixelu
      % Amplitudova charakteristika - asymptoticka
      [am,wa] = Asy(num,den);
      line((log10(wa)+abs(w1(1)))*sc+xoffset,am*jedndelka/20+ypos,'Color','r','LineStyle','--');
      % Popisky sklonu asymptot
      % Nejdrive zjistime, jestli je zaskrtnute zaskrtavatko
      amf = findobj('Tag','cb_frsklon');
      if (get(amf,'Value') > 0)
	      amf = [am(1)];
	      waf = [wa(1)];
         for i = 1:length(wa)-1
            % Vypustime po sobe nasledujici stejne body
      	   if (wa(i+1)-wa(i))>0
         	   waf = [waf wa(i+1)];
            	amf = [amf am(i+1)];
	         end                  
   	   end
			for i = 1:length(waf)-1
	         sklon = (amf(i+1)-amf(i))/(log10(waf(i+1))-log10(waf(i)));	% Sklon v dB/dek
   	      txt = text(((log10(waf(i+1))+log10(waf(i)))/2+abs(w1(1)))*sc+xoffset,...
      	      (amf(i+1)+(amf(i)-amf(i+1))/2)*jedndelka/20+ypos+15,[num2str(round(sklon))],'FontSize',8,...
         	   'HorizontalAlignment','left');
	      end
   	end   
   end
	if (pop == 1)|(pop == 3)
      % Fazova charakteristika
      % Popisky na ose fi
		popisky = {'\pi/2' '\pi' '\pi/2' '\pi'};      
      if ksi == 0
         for i = 0:1
   	   	txt = text(fix+65,ypos+(i+1)*jedndelka,popisky(i+3),'FontSize',8,'HorizontalAlignment','left','Color','r');
      	   txt = line(fix+50,ypos+(i+1)*jedndelka,'Color','k','Marker','+','MarkerSize',3);
	      end
         txt = text(fix+65,ypos-20,'0','FontSize',8,'Color','r');        
         txt = text(395,ypos-100,'Zmna fzov charakteristiky!','FontSize',8,'Color','r',...
         	'HorizontalAlignment','center','FontName','MS Sans Serif');
	      % hodnoty zespoda nahoru rostou do zaporu!
   	   line(((w1(:)+abs(w1(1)))*sc+xoffset),p(:)*jedndelka/90+ypos,'Color','b',...
            'LineStyle','-.','LineWidth',.5);                
      else         
			popisky = {'-3\pi/2' '' '-\pi/2' ' 0'};
	      for i = 0:1
   	   	txt = text(fix+65,ypos-(i+1)*jedndelka,popisky(i+3),'FontSize',8,'HorizontalAlignment','left');
      	   txt = line(fix+50,ypos-(i+1)*jedndelka,'Color','k','Marker','+','MarkerSize',3);
	      end
         txt = text(fix+65,ypos-20,'-\pi','FontSize',8);        
	      % hodnoty zespoda nahoru rostou do zaporu!
   	   line(((w1(:)+abs(w1(1)))*sc+xoffset),-p(:)*jedndelka/90+ypos-2*jedndelka,'Color','b',...
            'LineStyle','-.','LineWidth',.5);       
      end      
   end
   frekvence = [0.01 0.1 1 10 100 1000 10000 100000];
   line((log10(frekvence)+abs(w1(1)))*sc+xoffset,ypos,'Color','r','Marker','+','MarkerSize',4);
   rozsah = [round(w1(1)) round(w1(length(w1)))];
   % Popisky omega na ose x
   % Leva hodnota - zarovnana doleva
   text((log10(frekvence(3+rozsah(1)))+abs(w1(1)))*sc+xoffset+15,ypos-15,num2str(frekvence(3+rozsah(1))),'Color','k',...
   		'HorizontalAlignment','left','FontSize',8);
   for i=rozsah(1)+1:rozsah(2)-1
	   text((log10(frekvence(3+i))+abs(w1(1)))*sc+xoffset,ypos-15,num2str(frekvence(3+i)),'Color','k',...
   		'HorizontalAlignment','center','FontSize',8);
   end
   % Prava hodnota - zarovnana doprava (aby to nelezlo do osy)
	text((log10(frekvence(3+rozsah(2)))+abs(w1(1)))*sc+xoffset-5,ypos-15,num2str(frekvence(3+rozsah(2))),'Color','k',...
      'HorizontalAlignment','right','FontSize',8);
   
   % Lomove frekvence
	%poly = sort(roots(den));
	%T = -1./poly;

	%	q1=(log10(T(1))+abs(w1(1)))*sc+xoffset;
   %	q2=(log10(T(2))+abs(w1(1)))*sc+xoffset;
   
% *************************************************************
% ****** FUNKCE PRO KRESLENI ASYMPTOT AMP. FREKV. CHAR. *******
% *************************************************************
% ****** (c) Miloslav Richter ******
function [am, wa] = Asy(cit,jmen)
% funkce pro kresleni asymptotickeho prubehu, vrati zlomy amplitudu a frekvenci
% testovaci prubeh
% asy([100 20 1],conv([1 0.2 1],[0.2 1 0]))
% nejdrive zjistim zesileni
% a casovek konstanty citatele a jmenovatele
[p z k] = tf2zp(cit,jmen);
% normalizovany tvar prenosove funkce - nejvyssi mocnina 
% citatele ma koeficient jedna, zesileni je v citatli
[num,den] = zp2tf(p,z,k);
% zesileni je takove cislo, ze posledni nenulove koeficienty 
% citatele a jmenovatele jsou rovny jedne
for i=length(num):-1:1
  if num(i)~=0 
    kn = num(i);
    break;
  end
end
for i=length(den):-1:1
  if den(i)~=0 
    kc = den(i);
    break;
  end
end
% tohle je zesileni soustavy
kv = kn / kc;
% ted ty poly a nuly
% nejdrive poly - ty jsou v z
% poly v nule
pn = 0;
for i=1:length(z)
  if z(i)==0
    pn = pn + 1;
  else
    break
  end
end
%pn; 
% musim prohledat ostatni poly, zda nejsou komplexni
% pokud jsou, musim vypitvat casovou konstantu
%z;
for i=pn+1:length(z)
  if imag(z(i)) ~= 0
% ma imaginarni cast ale jsou komplexne zdruzene 
% -> bereme jen jednou    
    if imag(z(i))>0
% ksi / T
      ksit = real(z(i));
      T = -1/sqrt(imag(z(i))*imag(z(i))+ksit*ksit);
% dvojnasobny koren v 1/T, predpoklad -> komplexni poly jdou zasebou
% a zacinaji kladnou imaginarni casti
      z(i) = 1/T;
      z(i+1) = 1/T ;
    end
  end
end
%z;
% ted komplexni ve jmenovateli
%p;
for i=1:length(p)
  if imag(p(i)) ~= 0
% ma imaginarni cast ale jsou komplexne zdruzene 
% -> bereme jen jednou    
    if imag(p(i))>0
% ksi / T
      ksit = real(p(i));
      T = -1/sqrt(imag(p(i))*imag(p(i))+ksit*ksit);
% dvojnasobny koren v 1/T, predpoklad -> komplexni poly jdou zasebou
% a zacinaji kladnou imaginarni casti
      p(i) = 1/T;
      p(i+1) = 1/T ;
    end
  end
end
%p;
% poly a nuly je potreba usporadat vzestupne, kvuli komplexnim korenum
p = -p;
z = -z;
p=sort(p);
z=sort(z);
po = -p;
clear p;
p = -z;
clear z;
z = po;
% pak ziskam jak to kresli bode
%figure
[mag,pha,w]=bode(cit,jmen);
%hold off
%semilogx(w,20*log10(mag))
%grid on
%hold on
% a vykreslim do bode to co mam
% celkovy pocet zlomu
pocet = length(z) + length(p);
% citace aktualniho polu a nuly
cp = pn + 1;
cn = 1;
% pocitam pocatek zesileni + sklon
amplituda = 20*log10(kv);
% plot([0.01 1],[amplituda amplituda])
sklon = pn;
amplituda = amplituda + log10(1/w(1))*20*sklon;
% vektory pro ulozeni frekvenci zlomu a hodnot asymptot
am=1:pocet+2-pn;
wa=1:pocet+2-pn;
citac = 1;
am(citac)=amplituda;
wa(citac)=w(1);
citac = citac+1;
% plot([0.01 1],[amplituda amplituda])
for i=cp:pocet
if cn > length(z)
% uz jen poly
  f=1;
 % sklon;
  if wa(citac-1) ~= -p(cp)
    amplituda = amplituda - sklon*log10(-p(cp)/wa(citac-1))*20;
  end
  sklon = sklon + 1;
  am(citac)=amplituda;
  wa(citac)=-p(cp);
  citac = citac+1;
  cp = cp+1;
elseif cp > length(p)
% uz jen nuly
   f=2;
   if wa(citac-1) ~= -z(cn)
    amplituda = amplituda - sklon*log10(-z(cn)/wa(citac-1))*20;
  end
  sklon = sklon - 1;
  am(citac)=amplituda;
  wa(citac)=-z(cn);
  citac = citac+1;
  cn = cn + 1; 
elseif z(cn) > p(cp)
% na rade je nula
  f=3;
%  sklon;
  if wa(citac-1) ~= -z(cn)
    amplituda = amplituda - sklon*log10(-z(cn)/wa(citac-1))*20;
  end
  sklon = sklon - 1;
  am(citac)=amplituda;
  wa(citac)=-z(cn);
  citac = citac+1;
  cn = cn + 1; 
else
% na rade je pol
  f=4;
  if wa(citac-1) ~= -p(cp)
    amplituda = amplituda - sklon*log10(-p(cp)/wa(citac-1))*20;
  end
  sklon = sklon + 1;
  am(citac)=amplituda;
  wa(citac)=-p(cp);
  citac = citac+1;
  cp = cp+1;
end
end
if am(citac-1) ~= w(length(w))
 amplituda = amplituda - sklon*log10(w(length(w))/wa(citac-1))*20;
end
%citac;
am(citac)=amplituda;
wa(citac)=w(length(w));

% ********************************************
% ****** FUNKCE PRO ZAOKROUHLENI CISEL *******
% ********************************************

function vysledek = Zaokrouhli(cislo, pocetmist)

vysledek = round(cislo * 10^pocetmist) / 10^pocetmist;

% ************************************************
% ****** FUNKCE PRO KRESLENI OS SE SIPKAMI *******
% ************************************************

function KresliOsy(params)
% Params je struktura, ktera obsahuje potrebna data
% Vypneme popisky (kvuli debilnimu chovani 'plot'u)

ax = findobj('Tag',params.axtag);
set(ax,'NextPlot','add');
%axes(ax);cla;

osax = line([params.osaxod params.osaxdo],[params.osaxypos params.osaxypos],'Color','k');
osay = line([params.osayxpos params.osayxpos],[params.osayod params.osaydo],'Color','k');
PlotArrow(params.sipkaxx,params.osaxypos,params.sipkasize,0)
PlotArrow(params.osayxpos,params.sipkayy,params.sipkasize,90)

set(ax,'XLim',[0 params.xlim],'YLim',[0 params.ylim]);

% **********************************************
% ****** FUNKCE PRO KRESLENI RAMECKU ... *******
% **********************************************

function KresliOkraj(osy)
% Params je struktura, ktera obsahuje potrebna data
% Vypneme popisky (kvuli debilnimu chovani 'plot'u)
	ax = findobj('Tag',osy);
%   set(ax,'NextPlot','add');
   axes(ax)
   lx = get(ax,'XLim');   ly = get(ax,'YLim');
   l = line([lx(1) lx(2)],[ly(1) ly(1)],'Color','k');	% dole
	l = line([lx(2) lx(2)],[ly(1) ly(2)],'Color','k');	% vpravo
   l = line([lx(1) lx(2)],[ly(2) ly(2)],'Color','k');	% nahore
   l = line([lx(1) lx(1)],[ly(1) ly(2)],'Color','k'); % vlevo
